/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.DemoResult
 *  fire.pb.battle.Fighter
 *  fire.pb.battle.ResultItem
 *  fire.pb.battle.SubResultItem
 *  fire.pb.course.CourseManager
 *  fire.pb.item.FoodItem
 *  fire.pb.item.IDurableItem
 *  fire.pb.item.ItemBase
 *  fire.pb.item.ItemMaps
 *  fire.pb.item.Module
 *  fire.pb.item.SItemBuff
 *  fire.pb.main.ConfigManager
 *  fire.pb.skill.fight.FightUseItem
 *  xbean.BattleInfo
 *  xbean.Fighter
 *  xtable.Properties
 */
package fire.pb.option;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.battle.BattleField;
import fire.pb.battle.DemoResult;
import fire.pb.battle.ResultItem;
import fire.pb.battle.SubResultItem;
import fire.pb.course.CourseManager;
import fire.pb.item.FoodItem;
import fire.pb.item.IDurableItem;
import fire.pb.item.ItemBase;
import fire.pb.item.ItemMaps;
import fire.pb.item.Module;
import fire.pb.item.SItemBuff;
import fire.pb.main.ConfigManager;
import fire.pb.option.BasicOperation;
import fire.pb.skill.fight.FightUseItem;
import java.util.LinkedList;
import xbean.BattleInfo;
import xbean.Fighter;
import xtable.Properties;

public class UseItem
extends BasicOperation {
    public static final int ITEM_USER_ROLE = 1;
    public static final int ITEM_USER_PET = 2;
    public static final int ITEM_USE_NO_CONSUME = 0;
    public static final int ITEM_USE_CONSUME = 1;
    public static final int ITEM_USE_CONSUME_ENDU = 2;
    private final int itemKey;

    public UseItem(BattleInfo battle, int operator, int aim, int itemKey) {
        super(battle, operator, aim);
        this.itemKey = itemKey;
    }

    @Override
    public int getOperateID() {
        return this.itemKey;
    }

    @Override
    public LinkedList<DemoResult> getDemoResult() {
        return null;
    }

    public String toString() {
        return this.getOperator() + "\t使用物品（itemkey = \t" + this.itemKey + ")给\t" + this.getAim();
    }

    @Override
    public ResultItem getResultItem() {
        if (this.resultItem != null) {
            if (this.resultItem.execute.operationtype == 14 || this.resultItem.execute.operationtype == 20) {
                return this.resultItem;
            }
            this.processActiveHidden();
        }
        return this.resultItem;
    }

    @Override
    public boolean checkEffective() {
        return true;
    }

    @Override
    public int getResultType() {
        return 0;
    }

    @Override
    public int getType() {
        return 3;
    }

    @Override
    public void process() {
        if (!this.checkOperator()) {
            this.resultItem.execute.attackerid = this.getOperator();
            this.resultItem.execute.operationtype = 20;
            SubResultItem subitem = new SubResultItem();
            subitem.subskillid = 0;
            subitem.subskillstarttime = 0;
            this.resultItem.subresultlist.add(subitem);
            return;
        }
        this.resultItem = null;
        fire.pb.battle.Fighter opfighter = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(this.getOperator());
        int usertype = 0;
        long roleId = 0L;
        Fighter owner = null;
        if (opfighter.getFighterBean().getFightertype() == 1) {
            roleId = opfighter.getFighterBean().getUniqueid();
            usertype = 1;
            owner = opfighter.getFighterBean();
        } else if (opfighter.getFighterBean().getFightertype() == 2) {
            int masterfid = this.getOperator() - 5;
            Fighter masterfighter = (Fighter)this.getBattle().getFighters().get(masterfid);
            if (masterfighter != null) {
                roleId = masterfighter.getUniqueid();
            }
            usertype = 2;
            owner = masterfighter;
        }
        if (roleId <= 0L) {
            return;
        }
        int aimRelation = BattleField.getItemAimRelation((BattleInfo)this.getBattle(), (int)this.getOperator(), (int)this.getAim());
        try {
            ItemBase item;
            ItemMaps bag;
            if (String.valueOf(this.itemKey).trim().endsWith("10086")) {
                bag = Module.getInstance().getItemMaps(roleId, 5, false);
                String str = String.valueOf(this.itemKey).substring(0, String.valueOf(this.itemKey).indexOf("10086"));
                item = bag.getItem(Integer.parseInt(str));
            } else {
                bag = Module.getInstance().getItemMaps(roleId, 1, false);
                item = bag.getItem(this.itemKey);
            }
            if (item == null) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：找不到物品。RoleId：").append(roleId).append(" ;ItemKey: ").append(this.itemKey));
                }
                return;
            }
            if (!this.checkRoleLevel(roleId, item)) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：使用者等级不符。RoleId：").append(roleId).append(" ;ItemId: ").append(item.getItemId()));
                }
                return;
            }
            if (opfighter.getFighterBean().getFightertype() == 1) {
                if ((item.getItemAttr().getInbattleuseto() & 1) == 0) {
                    if (BattleField.logger.isDebugEnabled()) {
                        BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：使用者不能是角色。RoleId：").append(roleId).append(" ;ItemId: ").append(item.getItemId()));
                    }
                    return;
                }
            } else if (opfighter.getFighterBean().getFightertype() == 2 && (item.getItemAttr().getInbattleuseto() & 2) == 0) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：使用者不能是宠物。RoleId：").append(roleId).append(" ;ItemId: ").append(item.getItemId()));
                }
                return;
            }
            if (!item.onUseInBattle(usertype, aimRelation)) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：物品使用对象不合法。RoleId：").append(roleId).append(" ;ItemId: ").append(item.getItemId()));
                }
                return;
            }
            LinkedList monsterIds = new LinkedList();
            SItemBuff sItemBuff = (SItemBuff)ConfigManager.getInstance().getConf(SItemBuff.class).get(item.getItemId());
            if (sItemBuff == null) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用物品：物品buff不存在。RoleId：").append(roleId).append(" ;ItemId: ").append(item.getItemId()));
                }
                return;
            }
            if (sItemBuff.monsterids != null) {
                monsterIds.addAll(sItemBuff.monsterids);
            }
            Integer usednum = (Integer)owner.getUseditems().get(item.getItemId());
            int itemtype = item.getItemAttr().getTypeid();
            int drugStuffTime = 0;
            int drugFoodTime = 0;
            int n = 0;
            if (itemtype == 275 || itemtype == 323) {
                drugStuffTime = (Integer)owner.getUseditems().get(0);
                if (drugStuffTime <= 0) {
                    if (BattleField.logger.isDebugEnabled()) {
                        BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用道具类型为").append(itemtype).append("的物品超出"));
                    }
                    return;
                }
            } else if (itemtype == 290 || itemtype == 291) {
                drugFoodTime = (Integer)owner.getUseditems().get(1);
                if (drugFoodTime <= 0) {
                    if (BattleField.logger.isDebugEnabled()) {
                        BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用道具类型为").append(itemtype).append("的物品超出"));
                    }
                    return;
                }
            } else if (itemtype == 25 && (n = ((Integer)owner.getUseditems().get(2)).intValue()) <= 0) {
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)new StringBuilder("ERROR 战斗内使用道具类型为").append(itemtype).append("的物品超出"));
                }
                return;
            }
            if (item instanceof FoodItem) {
                this.getBattle().getEngine().setItemQuality(Integer.valueOf(((FoodItem)item).getQuality()));
            }
            FightUseItem skill = new FightUseItem(this.getBattle(), this.getOperator(), this.getAim(), sItemBuff.inskill_id, 3, item.getItemAttr().getInbattle(), item, monsterIds);
            this.resultItem = skill.process();
            if (this.resultItem != null && this.resultItem.execute.operationtype == 0) {
                this.resultItem.execute.operationtype = this.getType();
            }
            if (this.resultItem != null && this.resultItem.execute.operationtype != 14 && this.resultItem.execute.operationtype != 20) {
                this.resultItem.execute.operationid = item.getItemId();
                if (item.getItemAttr().getUseup() == 2) {
                    if (item instanceof IDurableItem) {
                        ((IDurableItem)item).addDurabilityWithSP(-1);
                    }
                } else if (item.getItemAttr().getUseup() == 1) {
                    bag.removeItemWithKey(this.itemKey, 1, YYLoggerTuJingEnum.tujing_Value_itemuse, 0, "战斗使用物品");
                }
                if (usednum == null) {
                    usednum = 0;
                }
                Integer integer1 = usednum;
                Integer integer2 = usednum = Integer.valueOf(usednum + 1);
                owner.getUseditems().put(item.getItemId(), usednum);
                if (itemtype == 275 || itemtype == 323) {
                    owner.getUseditems().put(0, --drugStuffTime);
                } else if (itemtype == 290 || itemtype == 291) {
                    owner.getUseditems().put(1, --drugFoodTime);
                } else if (itemtype == 25) {
                    owner.getUseditems().put(2, --n);
                }
                fire.pb.battle.Fighter ownerfighter = (fire.pb.battle.Fighter)this.getBattle().getFighterobjects().get(opfighter.getFighterBean().getFightertype() == 2 ? this.getOperator() - 5 : this.getOperator());
                ownerfighter.sendAlreadyUsedItems();
                this.processItemPoison(this.resultItem, item);
                CourseManager.achieveCourse((long)ownerfighter.getFighterBean().getUniqueid(), (int)17, (int)item.getItemId(), (int)0);
                if (BattleField.logger.isDebugEnabled()) {
                    BattleField.logger.debug((Object)(this.getOperator() + "\t成功对\t" + this.getAim() + "\t使用物品\t" + item.getItemAttr().getName()));
                }
            } else if (this.resultItem == null) {
                this.resultItem = new ResultItem();
                this.resultItem.execute.attackerid = this.getOperator();
                this.resultItem.execute.operationtype = 20;
                this.resultItem.execute.operationid = 141179;
            }
            if ((this.resultItem.execute.operationtype == 14 || this.resultItem.execute.operationtype == 20) && BattleField.logger.isDebugEnabled()) {
                BattleField.logger.debug((Object)(this.getOperator() + "\t对\t" + this.getAim() + "\t使用物品\t" + item.getItemAttr().getName() + "\t失败"));
            }
        }
        catch (Exception e) {
            BattleField.logger.error((Object)"战斗内使用物品出错", (Throwable)e);
        }
        this.getBattle().getEngine().setItemQuality(Integer.valueOf(0));
    }

    private void processItemPoison(ResultItem resultItem, ItemBase item) {
    }

    private boolean checkRoleLevel(long roleId, ItemBase item) {
        int rolelevel = Properties.selectLevel((Long)roleId);
        return rolelevel >= item.getItemAttr().getNeedlevel();
    }

    @Override
    public boolean canChangeAim() {
        return false;
    }
}

